const web = require("o-web");
const hot = require("o-hot");
let urlencode = global.encodeURIComponent;
let mailbox = {};
mailbox.host = "https://www.bimwook.com:11180";
mailbox.uid = "";
mailbox.secret = "";
mailbox.randomint = function(){
  var ret = [];
  var len = 16;
  for(var i=0; i<len; i++){
    ret.push(Math.floor(Math.random()*10));
  }
  return ret.join("");
};
mailbox.token = "0000000000000000000000000000000000000000";
mailbox.receive = async function(){
  var data = [];
  data.push('token=' + urlencode(this.token));
  data.push('secret=' + urlencode(this.secret));
  var o = await web.get(`${this.host}/mailbox/alive/receive.do?${data.join('&')}`);
  var ret = {};
  ret.result = false;
  ret.sender = (o.text.match(/^Sender: (.+)$/m)||["",""])[1];
  ret.result = (o.text!="NO-DATA") && (ret.sender!="");
  ret.datetime = (o.text.match(/^Created-At: (.+)$/m)||["","00:00:00"])[1];
  var p = o.text.indexOf("\r\n\r\n");
  if(p>-1){
    ret.text = o.text.slice(p+4).trim();
  }
  else {
    ret.text = "";
    if(o.text!="NO-DATA"){
      console.log(`[${hot.color.red("ERROR")}] ${o.text}`);
    }
  }
  return ret;
};

mailbox.send = async function(receiver, text){
  let data = [];
  let url = `${this.host}/mailbox/alive/send.do`;
  data.push('status=0');
  data.push('secret=' + urlencode(this.secret));
  data.push('token=' + urlencode(this.token) );
  data.push('receiver=' + urlencode(receiver) );
  data.push('text=' + urlencode(text) );
  var o = await web.post(url, data.join("&"));
  var ret = (o.text.trim()=="OK");
  if(!ret){
    console.log(`[${hot.color.red("ERROR")}] ${o.text}`);
  }
  return ret;
};

mailbox.reset = async function(uid, secret){
  this.uid = uid;
  this.secret = secret;
  let o = await web.get(`${this.host}/mailbox/alive/token.do?role=robot&uid=${urlencode(this.uid)}&secret=${urlencode(this.secret)}`);
  this.token = (o.text.match(/\d{16}\|(\d{40})/)||["",""])[1];
  console.log("token=" + this.token);
  if(this.token==""){
    let data = [];
    data.push(`uid=${urlencode(this.uid)}`);
    data.push(`secret=${urlencode(this.secret)}`);
    let o = await web.post(`${this.host}/mailbox/alive/token.do?cmd=renew`, data.join('&'));
    //console.log(o.text);
    this.token = (o.text.match(/\d{16}\|(\d{40})/)||["",""])[1];
    if(this.token==""){
      console.log(`[${hot.color.red("ERROR")}] ACCESS-DENIED`);
      return false;
    }
  }
  return true;
};

module.exports = {
  send: async function(receiver, text){
    await mailbox.send(receiver, text);
  },
  receive: async function(){
    return await mailbox.receive();
  },
  reset: async function(uid, secret, token){
    mailbox.uid = uid;
    mailbox.secret = secret;
    if(!token){
      await mailbox.reset(uid, secret);
    }
  },
  randomint: function(){
    return mailbox.randomint();
  }
};
