let hot = require("o-hot");
let web = require("o-web");
let ws = require("./ws.js");
let mailbox = require("./mailbox.js");

-async function(){
  await mailbox.reset("chatman", "5374752009920701");
}();

let fn = {};
fn.now = function() {
  let d = new Date();
  let ret = [];
  ret.push(d.getFullYear());
  ret.push("-");
  ret.push( ('00' + (d.getMonth()+1)).slice(-2) );
  ret.push("-");
  ret.push( ('00' + d.getDate()).slice(-2) );
  ret.push(" ");
  ret.push( ('00' + d.getHours()).slice(-2) );
  ret.push(":");
  ret.push( ('00' + d.getMinutes()).slice(-2) );
  ret.push(":");
  ret.push( ('00' + d.getSeconds()).slice(-2) );
  return ret.join('');
};

fn.startwith = function(source, tofind){
  return (source||"").indexOf(tofind)==0;
}

let woo = {};
woo.host = "0.0.0.0";
woo.port = 11111;
woo.sender = null;
woo.text= "";
woo.sockets = [];
woo.timer = null;

woo.onconnected = function(item) {
  item.id = Math.random().toString(36);
  //console.log(item.headers);
  this.sender.send(item, "$ok uid=" + item.id);
};
woo.ondata = async function(item, frame) {
  var me = this;
  var text = frame.data.toString();
  if(fn.startwith(text, "$nick ")){
    var mx = text.match(/^\$nick (.+)$/m);
    if(mx){
      item.nickname = mx[1];
      this.sender.send(item, "$ok nickname=" + item.nickname);    
    }
    else {
      this.sender.send(item, "$error Bad-Nickname");    
    }
    var data = [`[${item.room}|${item.nickname||item.id}] ${text}`];
    data.push("uid:" + item.id);
    data.push("network: " + item.socket.remoteAddress + ":" + item.socket.remotePort);
    data.push("x-forwarded-for: " + item.headers["X-Forwarded-For"]);
    data.push("ua: " + item.headers["User-Agent"]);    
    await mailbox.send("/o/robot/x-11180", data.join("\r\n"));
  }
  else if(fn.startwith(text, "$room ")){
    var mx = text.match(/^\$room (\d{6})$/m);
    if(mx){
      item.room = mx[1];
      this.sender.send(item, "$ok room=" + item.room);        
    }
    else {
      this.sender.send(item, "$error Bad-Room");
    }
    var data = [`[${item.room}|${item.nickname||item.id}] ${text}`];
    data.push("uid:" + item.id);
    data.push("network: " + item.socket.remoteAddress + ":" + item.socket.remotePort);
    data.push("x-forwarded-for: " + item.headers["X-Forwarded-For"]);
    await mailbox.send("/o/robot/x-11180", data.join("\r\n"));
  }
  else if(fn.startwith(text, "$text\r\n")){
    var data = [];
    data.push("$text");
    data.push("Uid: " + item.id);
    data.push("Sender: " + (item.nickname||""));
    data.push("Created-At: " + fn.now());
    data.push("Network: " + item.socket.remoteAddress + ":" + item.socket.remotePort);
    data.push("X-Forwarded-For: " + item.headers["X-Forwarded-For"]);
    data.push('');
    data.push(text.slice(7));
    var txt = data.join("\r\n");
    for(let i=0; i<me.sockets.length; i++){
      let item = me.sockets[i];
      try{
        this.sender.send(item, txt);
      }
      catch(e){
        console.log(e);
      }
    }
    await mailbox.send("/o/robot/x-11180", `[${item.room}|${item.nickname||item.id}] ${txt}`);
  }
  else if(text=="$heartbeat"){
  
  }
  console.log(`[${item.room}|${hot.color.blue(item.nickname||item.id)}] ${text}`);
};
woo.onclose = function() {
  if(this.timer){
    clearInterval(this.timer);
    this.timer = null;
  }
};
woo.start = function(sender) {
  this.sender = sender;
};

ws.WebSocket(woo);
